routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes(['verify' => true]);

Route::group(['prefix' => 'admin', 'namespace' => 'Admin', 'as' => 'admin.'], function () {

    Route::group(['middleware' => ['auth:web', 'can:admin']], function () {

        Route::get('admin', ['as' => 'dashboard.index', 'uses' => 'DashboardController@index']);

        Route::get('dashboard', ['as' => 'dashboard.index', 'uses' => 'DashboardController@index']);

    // Attributes routes
        include('admin/attributes.php');

    // Categories routes
        include('admin/categories.php');

    // Brands routes
        include('admin/brands.php');

    // Warehouses routes
        include('admin/warehouses.php');

    // Products routes
        include('admin/products.php');

    // Images routes
        include('admin/images.php');

    // Orders routes
        include('admin/orders.php');

    // Users routes
        include('admin/users.php');

    // Roles routes
        include('admin/roles.php');

    });
});

Route::group(['namespace' => 'Client', 'as' => 'client.'], function () {

    include('client/auth.php');

    Route::get('/'                              , ['as' => 'home'           , 'uses' => 'HomeController@index']);
    Route::get('o-nama'                         , ['as' => 'about_us'       , 'uses' => 'HomeController@aboutUs']);
    Route::get('kontakt'                        , ['as' => 'contact'        , 'uses' => 'ContactController@index']);
    Route::post('poruka'                        , ['as' => 'contact.send'   , 'uses' => 'ContactController@send']);
    Route::get('proizvod/{product}/{slug}'      , ['as' => 'product'        , 'uses' => 'ProductsController@show']);

    Route::get('proizvodi/{category?}/{slug?}/pretraga' , ['as' => 'search'     , 'uses' => 'ProductsController@search']);
    Route::get('json/{category?}/{slug?}/pretraga'      , ['as' => 'search.json', 'uses' => 'ProductsController@searchJson']);

    Route::get('privremena-korpa'                               , ['as' => 'cart.preview'           , 'uses' => 'CartController@preview']);
    Route::get('korpa'                                          , ['as' => 'cart.index'             , 'uses' => 'CartController@index'])->middleware(['auth', 'verified']);
    Route::get('cart/all'                                       , ['as' => 'cart.all'               , 'uses' => 'CartController@all'])->middleware(['auth', 'verified']);
    Route::get('cart/destroy/{cart}'                            , ['as' => 'cart.destroy'           , 'uses' => 'CartController@destroy'])->middleware(['auth', 'verified']);
    Route::post('cart/store/{activeProduct}/{productVariant}'   , ['as' => 'cart.create'            , 'uses' => 'CartController@store']);
    Route::post('cart/quantity/update'                          , ['as' => 'cart.quantity.update'   , 'uses' => 'CartController@quantityUpdate'])->middleware(['auth', 'verified']);
    Route::post('order/create'                                  , ['as' => 'order.create'           , 'uses' => 'OrderController@store'])->middleware(['auth', 'verified']);
    Route::get('porudzbina/{order}'                             , ['as' => 'order.show'             , 'uses' => 'OrderController@show'])->middleware(['auth', 'verified']);
});

app/Http/Controllers/Client/CartController.php
<?php

namespace App\Http\Controllers\Client;

use App\Http\Controllers\Controller;
use App\Src\Base\Errors;
use App\Src\Base\Events\DestroyModelEvent;
use App\Src\Base\Exceptions\ModelsNotUpdatedException;
use App\Src\Carts\Cart;
use App\Src\Carts\Contracts\CartRepositoryInterface;
use App\Src\Carts\Requests\StoreCartRequest;
use App\Src\Carts\Requests\UpdateCartQuantityRequest;
use App\Src\Carts\Resources\CartSummaryResource;
use App\Src\Products\Product;
use App\Src\Products\Variants\Contracts\ProductVariantRepositoryInterface;
use App\Src\Products\Variants\ProductVariant;
use App\Src\Services\Contracts\CreateCartInterface;
use App\Src\Services\Models\Destroy\Cart\DestroyCartService;
use App\Src\Services\Models\Edit\Cart\EditManyCartQuantities;
use App\Src\Services\Models\Get\Cart\GetCartSeessionService;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;
use Illuminate\Support\Facades\DB;

class CartController extends Controller
{
    /**
     * Preview cart for unauth users.
     *
     * @param GetCartSeessionService $cartSeessionService
     * @param ProductVariantRepositoryInterface $productVariantRepository
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function preview(GetCartSeessionService $cartSeessionService, ProductVariantRepositoryInterface $productVariantRepository)
    {
        $variants = $productVariantRepository->findByIds(array_column($cartSeessionService->get(), 'product_variant'));

        return view('client.cart-preview', compact('variants'));
    }


    /**
     * Show cart.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('client.summary');
    }


    /**
     * Store cart for selected product variant.
     *
     * @param StoreCartRequest $request
     * @param Product $product
     * @param ProductVariant $productVariant
     * @param CreateCartInterface $createCart
     * @return \Illuminate\Http\JsonResponse
     */
    public function store(StoreCartRequest $request, Product $product, ProductVariant $productVariant, CreateCartInterface $createCart)
    {
        if (! $createCart->create($productVariant, $request->validated())) {

            return response()->json(['message' => 'Error'], 400);
        }

        return response()->json(['message' => 'Success'], 200);
    }


    /**
     * Get cart summary
     *
     * @param CartRepositoryInterface $cartRepository
     * @return AnonymousResourceCollection
     */
    public function all(CartRepositoryInterface $cartRepository): AnonymousResourceCollection
    {
        return CartSummaryResource::collection($cartRepository->getUserCart(auth()->user()));
    }


    /**
     * Destroy cart.
     *
     * @param Cart $cart
     * @param DestroyCartService $destroyCartService
     * @return \Illuminate\Http\JsonResponse
     */
    public function destroy(Cart $cart, DestroyCartService $destroyCartService)
    {
        try {

            DB::beginTransaction();

            event(new DestroyModelEvent($destroyCartService, $cart));

        } catch (\Exception $exception) {

            DB::rollBack();

            return response()->json(Errors::MODEL_NOT_DELETED, 400);
        }

        DB::commit();

        return response()->json(['message' => 'Success'], 200);
    }


    /**
     * Update items quantity in cart.
     *
     * @param UpdateCartQuantityRequest $request
     * @param EditManyCartQuantities $editManyCartQuantities
     * @return \Illuminate\Http\JsonResponse
     */
    public function quantityUpdate(UpdateCartQuantityRequest $request, EditManyCartQuantities $editManyCartQuantities)
    {
        try {

            DB::beginTransaction();

            if (! $editManyCartQuantities->edit($request->validated())) {

                throw new ModelsNotUpdatedException(Errors::MODElS_NOT_UPDATED['error_message']);
            }

        } catch (\Exception $exception) {

            DB::rollBack();

            return response()->json(Errors::MODEL_NOT_DELETED, 400);
        }

        DB::commit();

        return response()->json(['message' => 'Success'], 200);
    }
}

app/Http/Controllers/Client/ContactController.php
<?php

namespace App\Http\Controllers\Client;

use App\Http\Controllers\Controller;
use App\Src\Mails\ContactMail;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Mail;

class ContactController extends Controller
{
    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('client.contact');
    }


    public function send(Request $request)
    {
        $this->validate($request, [
            'name'      => 'required',
            'email'     => 'required|email',
            'message'   => 'required'
        ]);

        Mail::to('harcstefan@gmail.com')
            ->queue(new ContactMail($request->only('name', 'email', 'message')));

        return redirect()->back()->with(['status' => 'Poruka je uspesno poslata!']);
    }
}

app/Http/Controllers/Client/HomeController.php
<?php

namespace App\Http\Controllers\Client;

use App\Http\Controllers\Controller;
use App\Src\Services\Home\GetHomeDataService;

class HomeController extends Controller
{
    /**
     * Index page
     *
     * @param GetHomeDataService $service
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index(GetHomeDataService $service)
    {
        return view('client.home')->with($service->getData());
    }


    /**
     * About us page.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function aboutUs()
    {
        return view('client.aboutUs');
    }


    /**
     * Address/Contact page.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function contact()
    {
        return view('client.address');
    }


    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function register()
    {
        return view('client.security.register');
    }

    /**
     * Products show/search page.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function products()
    {
        return view('client.products');
    }
}

app/Http/Controllers/Client/OrderController.php
<?php

namespace App\Http\Controllers\Client;

use App\Http\Controllers\Controller;
use App\Src\Base\Errors;
use App\Src\Base\Events\CreateModelEvent;
use App\Src\Orders\Order;
use App\Src\Orders\Queries\LoadShowOrderHelper;
use App\Src\Orders\Requests\ClientStoreOrderRequest;
use App\Src\Services\Models\Create\Order\ClientCreateOrderService;
use Illuminate\Support\Facades\DB;

class OrderController extends Controller
{
    /**
     * Show order info.
     *
     * @param Order $order
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Order $order)
    {
        if ($order->user_id !== auth()->user()->id) {

            abort(404);
        }

        $order->load(LoadShowOrderHelper::loadArray());

        return view('client.order', compact('order'));
    }


    /**
     * Store order.
     *
     * @param ClientStoreOrderRequest $request
     * @param ClientCreateOrderService $clientCreateOrderService
     * @return \Illuminate\Http\JsonResponse
     */
    public function store(ClientStoreOrderRequest $request, ClientCreateOrderService $clientCreateOrderService)
    {
        try {

            DB::beginTransaction();

            event(new CreateModelEvent($clientCreateOrderService, $request->validated()));

        } catch (\Exception $exception) {

            DB::rollBack();

            return response()->json($exception->getMessage(), 400);
        }

        DB::commit();

        return response()->json(['message' => 'Success'], 200);
    }
}

app/Http/Controllers/Client/ProductsController.php
<?php

namespace App\Http\Controllers\Client;

use App\Http\Controllers\Controller;
use App\Src\Attributes\Contracts\AttributeRepositoryInterface;
use App\Src\Brands\Contracts\BrandRepositoryInterface;
use App\Src\Categories\Category;
use App\Src\Products\Contracts\ProductRepositoryInterface;
use App\Src\Products\Product;
use App\Src\Products\Resources\ProductSearchResource;
use Illuminate\Contracts\View\Factory;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;
use Illuminate\View\View;

class ProductsController extends Controller
{
    /**
     * Show product data.
     *
     * @param Product $product
     * @param AttributeRepositoryInterface $attributeRepository
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Product $product, AttributeRepositoryInterface $attributeRepository)
    {
        $product->load('brand', 'variants.productAttributeValues.attributeValue.productAttribute', 'variants.warehouseInventories.warehouse');

        $attributes = $attributeRepository->getProductAttributes($product);

        return view('client.product', compact('product', 'attributes'));
    }


    /**
     * Search products table.
     *
     * @param Category $category
     * @param Request $request
     * @param BrandRepositoryInterface $brandRepository
     * @param ProductRepositoryInterface $productRepository
     * @return AnonymousResourceCollection|Factory|View
     */
    public function search(Category $category, Request $request, BrandRepositoryInterface $brandRepository, ProductRepositoryInterface $productRepository)
    {
        $products = $productRepository->searchProducts($request->all(), $category);

        $products->appends($request->all());

        $brands         = $brandRepository->all();
        $subCategories  = $category->children;

        return view('client.products', compact('products', 'brands', 'category', 'subCategories'));
    }


    /**
     * Search products table.
     *
     * @param Category $category
     * @param Request $request
     * @param BrandRepositoryInterface $brandRepository
     * @param ProductRepositoryInterface $productRepository
     * @return AnonymousResourceCollection|Factory|View
     */
    public function searchJson(Category $category, Request $request, BrandRepositoryInterface $brandRepository, ProductRepositoryInterface $productRepository)
    {
        $products = $productRepository->searchProducts($request->all(), $category);

        $products->appends($request->all());

        return ProductSearchResource::collection($products);
    }
}

resources/views/client/layouts/foot.blade.php
</body>

    @routes

    <script src="{{ mix('js/client/client.js') }}"></script>

    @yield('scripts')

</html>

resources/views/client/layouts/footer.blade.php
<footer>
    <div class="row text-center text-md-left">
        <div class="col-sm-12 col-md">
            <a href="{{ route('client.home') }}" class="logo">
                <img src="{{ asset('/img/logo.png') }}" alt="Harc Fitness Logo">
            </a>
        </div>
        <div class="col-sm-6 col-md mt-3 mt-md-0">
            <ul class="list-group">
                <li class="list-group-item border-0">Harcfitnes</li>
                <li class="list-group-item border-0"><a href="{{ route('client.home') }}">Početna</a></li>
                <li class="list-group-item border-0"><a href="{{ route('client.about_us') }}">O nama</a></li>
                <li class="list-group-item border-0"><a href="{{ route('client.contact') }}">Kontakt</a></li>
            </ul>
        </div>
        <div class="col-sm-6 col-md mt-3 mt-md-0">
            <ul class="list-group">
                <li class="list-group-item border-0">Kategorije</li>
                @foreach($categories as $category)
                    <li class="list-group-item border-0"><a href="{{ route('client.search', $category->id, $category->slug) }}">{{ ucfirst($category->name) }}</a></li>
                @endforeach
            </ul>
        </div>
        <div class="col-sm-6 col-md mt-3 mt-md-0">
            <ul class="list-group">
                <li class="list-group-item border-0">Zaštita potrošaca?</li>
                <li class="list-group-item border-0">Garancija</li>
                <li class="list-group-item border-0">Kvalitet</li>
                <li class="list-group-item border-0">Dostava</li>
                <li class="list-group-item border-0">Brzina</li>
            </ul>
        </div>
        <div class="col-sm-6 col-md mt-3 mt-md-0">
            <ul class="list-group">
                <li class="list-group-item border-0">Kontakt</li>
                <li class="list-group-item border-0">
                    <a href="tel:+381644697270" class="contact-icon">
                        <i class="fas fa-phone"></i>
                        +381 64 469 72 70
                    </a>
                    <a href="{{ route('client.contact') }}" class="email">
                        harcstefan@gmail.com
                    </a>
                </li>
                <li class="list-group-item border-0">
                    <a href="#" class="social-icons">
                        <i class="fab fa-facebook-square"></i>
                    </a>
                    <a href="#" class="social-icons">
                        <i class="fab fa-instagram"></i>
                    </a>
                </li>
            </ul>
        </div>
    </div>
</footer>

resources/views/client/layouts/head.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="csrf-token" content="{{ csrf_token() }}">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta property="fb:app_id" content="{{ config('services.facebook.client_id') }}"/>

    @yield('metas')


    <title>HarcFitness</title>

    <link rel="apple-touch-icon" sizes="180x180" href="{{ asset('/') }}apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="{{ asset('/') }}favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="{{ asset('/') }}favicon-16x16.png">
    <link rel="manifest" href="{{ asset('/') }}site.webmanifest">

    <link rel="stylesheet" href="{{ mix('css/client/client.css') }}">

</head>
<div class="se-pre-con">
    <span class="spinner-border spinner-border-sm"
          role="status" aria-hidden="true"
          style="width: 3rem; height: 3rem; color: #69cce3; margin: auto; top: 45%; left: 48%; position: relative"></span>
</div>
<body>

resources/views/client/layouts/header.blade.php
<nav class="">
    <div class="shop-navigation">
        <div class="shop-basketWrap">
            <a href="{{ route('client.cart.' . (auth()->check() ? 'index' : 'preview')) }}">
                <i class="fas fa-shopping-cart"></i>
                <span class="shop-basket-items">{{ $productsInCart }}</span>
                <span>Korpa</span>
            </a>
        </div>
        <div class="shop-userWrap">
            <a href="#"
               class="dropdown-toggle"
               role="button"
               id="registration"
               data-toggle="dropdown"
               aria-haspopup="true" aria-expanded="false"
            >
                <i class="fas fa-user"></i>
                <span>{{ auth()->check() ? auth()->user()->name : 'Korisnik' }}</span>
            </a>
            <div class="dropdown-menu registration-dropdown" aria-labelledby="registration">
                @if(! auth()->check())
                    <a class="dropdown-item" href="{{ route('login') }}">Uloguj se</a>
                    <a class="dropdown-item" href="{{ route('register') }}">Registruj se</a>
                @else
                    <a class="dropdown-item" href="{{ route('logout') }}"
                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                        Izloguj se
                    </a>

                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                        @csrf
                    </form>
                @endif
            </div>
        </div>
    </div>
    <div class="main-navigation">

        <a class="main-logo" href="{{ route('client.home') }}">
            <img src="{{asset('/img/logo.png')}}" alt="Harc Fitness Logo">
        </a>

        <nav class="navbar navbar-expand-lg">

            {{--<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#smallNav"--}}
                    {{--aria-controls="smallNav" aria-expanded="false" aria-label="Toggle navigation">--}}
                {{--<i class="fas fa-bars"></i>--}}
            {{--</button>--}}

            {{--<div class="collapse navbar-collapse" id="smallNav">--}}

                <ul class="nav justify-content-center">
                    <li class="nav-item">
                        <a class="nav-link {{ \Illuminate\Support\Facades\Route::currentRouteName() == 'client.home' ? 'active' : '' }}"
                           href="{{ route('client.home') }}">Početna</a>
                    </li>
                    {{--<li class="nav-item">--}}
                        {{--<a class="nav-link {{ \Illuminate\Support\Facades\Route::currentRouteName() == 'client.products' ? 'active' : '' }}"--}}
                           {{--href="{{ route('client.search') }}">Proizvodi</a>--}}
                    {{--</li>--}}
                    <li class="nav-item">
                        <a class="nav-link {{ \Illuminate\Support\Facades\Route::currentRouteName() == 'client.about_us' ? 'active' : '' }}"
                           href="{{ route('client.about_us') }}">O nama</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link {{ \Illuminate\Support\Facades\Route::currentRouteName() == 'client.contact' ? 'active' : '' }}"
                           href="{{ route('client.contact') }}">Kontakt</a>
                    </li>
                </ul>

            @if(\Illuminate\Support\Facades\Route::currentRouteName() != 'client.contact')

                <button class="navbar-toggler navbar-dark" type="button" data-toggle="collapse" data-target="#navbarNav"
                        aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>

            @endif

            {{--</div>--}}
        </nav>
    </div>
    @if(\Illuminate\Support\Facades\Route::currentRouteName() != 'client.contact')
        <div class="large-navigation">
            <nav class="navbar navbar-expand-lg navbar-light" style="padding: 0 !important;">
                <div class="collapse navbar-collapse" id="navbarNav">
                    <ul class="navbar-nav">
                        @foreach($categories as $category)
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" href="{{ route('client.search', [$category->id, $category->slug]) }}" id="navbarDropdownMenuLink" role="button"
                                   data-toggle="" aria-haspopup="true" aria-expanded="true">

                                    <div class="item-frame">
                                        @if($category->icon)
                                            <img class="item-img" src="{{ route('images.cache', ['original', $category->icon->src]) }}" alt="Harc Fitness {{ $category->name }}">
                                        @endif
                                        <p class="item-name">{{ $category->name }}</p>
                                    </div>
                                </a>
                                @if ($category->children->count())
                                    <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                                        <div class="d-flex">
                                            <div>
                                                {{--<h4 class="dropdown-item">{{ $category->name }}</h4>--}}
                                                @foreach($category->children as $child)
                                                    <a class="dropdown-item" href="{{ route('client.search', [$category->id, $category->slug, 'subCategories' => $child->id]) }}">{{ $child->name }}</a>
                                                @endforeach
                                            </div>
                                        </div>
                                    </div>
                                @endif
                            </li>
                        @endforeach
                    </ul>
                </div>
            </nav>
        </div>
    @endif
</nav>

resources/views/client/layouts/similar-products.blade.php
<div class="similar-slider recommend-wrapper">
    <div class="container">
        <div class="row">
            <div class="col-md-8">
                <h2 class="title">Slicni proizvodi</h2>
            </div>
        </div>

        <div class="row">
            <div class="col-sm-12">
                <div class="similar-products">
                    @foreach($product->relatedProducts as $product)
                        <div class="product-frame" onclick="window.location='{{ route('client.product', [$product->id, $product->slug]) }}';">
                            <img src="{{ route('images.cache', ['medium', $product->main_image->src]) }}" alt="{{ $product->name }}">

                            <div class="text-frame">
                                <h4><a href="{{ route('client.product', [$product->id, $product->slug]) }}">{{ $product->name }}</a></h4>
                            </div>

                            @if($product->active)
                                <p class="price">Cena Od: {{ number_format((float) $product->cheapestVariant->price, 2, '.', '') }} rsd</p>
                            @else
                                <p class="price">Proizvod nije dostupan</p>
                            @endif

                            <a href="{{ route('client.product', [$product->id, $product->slug]) }}" class="btn btn-outline-primary">DETALJNIJE</a>
                        </div>
                    @endforeach
                </div>
            </div>
        </div>
    </div>
</div>